Package com.io7m.jregions.core.parameterized.sizes

# Class PVolumeSizeI.Builder<S>

java.lang.Object
com.io7m.jregions.core.parameterized.sizes.PVolumeSizeI.Builder<S>

Enclosing class:
  PVolumeSizeI<S>

    public static final class PVolumeSizeI.Builder<S>
    extends java.lang.Object

Builds instances of type `PVolumeSizeI`. Initialize attributes and then invoke the `build()` method to create an immutable instance.

`Builder` is not thread-safe and generally should not be stored in a field or collection, but instead used immediately to create instances.

- ## Method Summary

  Modifier and Type | Method | Description
  --- | --- | ---
  `PVolumeSizeI<S>` | `build()` | Builds a new `PVolumeSizeI`.
  `PVolumeSizeI.Builder<S>` | `from​(PVolumeSizeIType<S> instance)` | Fill a builder with attribute values from the provided `com.io7m.jregions.core.parameterized.sizes.PVolumeSizeIType` instance.
  `PVolumeSizeI.Builder<S>` | `from​(VolumeSizeValuesIType instance)` | Fill a builder with attribute values from the provided `com.io7m.jregions.core.unparameterized.sizes.VolumeSizeValuesIType` instance.
  `PVolumeSizeI.Builder<S>` | `setSizeX​(int sizeX)` | Initializes the value for the `sizeX` attribute.
  `PVolumeSizeI.Builder<S>` | `setSizeY​(int sizeY)` | Initializes the value for the `sizeY` attribute.
  `PVolumeSizeI.Builder<S>` | `setSizeZ​(int sizeZ)` | Initializes the value for the `sizeZ` attribute.

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Method Details

  - ### from

    public final PVolumeSizeI.Builder<S> from​(PVolumeSizeIType<S> instance)
    Fill a builder with attribute values from the provided `com.io7m.jregions.core.parameterized.sizes.PVolumeSizeIType` instance.
    Parameters:
      `instance` - The instance from which to copy values
    Returns:
      `this` builder for use in a chained invocation

  - ### from

    public final PVolumeSizeI.Builder<S> from​(VolumeSizeValuesIType instance)
    Fill a builder with attribute values from the provided `com.io7m.jregions.core.unparameterized.sizes.VolumeSizeValuesIType` instance.
    Parameters:
      `instance` - The instance from which to copy values
    Returns:
      `this` builder for use in a chained invocation

  - ### setSizeX

    public final PVolumeSizeI.Builder<S> setSizeX​(int sizeX)
    Initializes the value for the `sizeX` attribute.
    Parameters:
      `sizeX` - The value for sizeX
    Returns:
      `this` builder for use in a chained invocation

  - ### setSizeY

    public final PVolumeSizeI.Builder<S> setSizeY​(int sizeY)
    Initializes the value for the `sizeY` attribute.
    Parameters:
      `sizeY` - The value for sizeY
    Returns:
      `this` builder for use in a chained invocation

  - ### setSizeZ

    public final PVolumeSizeI.Builder<S> setSizeZ​(int sizeZ)
    Initializes the value for the `sizeZ` attribute.
    Parameters:
      `sizeZ` - The value for sizeZ
    Returns:
      `this` builder for use in a chained invocation

  - ### build

    public PVolumeSizeI<S> build()
    Builds a new `PVolumeSizeI`.
    Returns:
      An immutable instance of PVolumeSizeI
    Throws:
      `java.lang.IllegalStateException` - if any required attributes are missing